# Project Dashboard Testplan

&nbsp;

## Background
This testplan is going to cover the new Project Dashboard. It will go over the figma design seen here - [Project Dashboard](https://www.figma.com/file/Yzgkpah3gDUbVjaqEfJoke/Livia-Labs?node-id=1070%3A83898)

&nbsp;

&nbsp;

| Test Scenario                  | Test Cases                                     | Description                                                                                                                                                                                                                                                                                                                                                            | Comments |
|--------------------------------|------------------------------------------------|------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|----------|
| Empty Slate- Free Account      | Welcome Header Message                    | If a user has no projects on a free account, then the user should be able to see the welcome header displaying the message, "Welcome to Storj :) You're ready to experience the future of cloud storage                                                                                                                                                                |          |
|                                | Project Stats Delay Message               | Even if a user has no projects on a free account, the user should still be able to see a message under the Project Stats header which alerts the user that the project storage and bandwidth activities take a few hours to show up on the graphs                                                                                                                      |          |
|                                | Click Upload Button                       | As a user with no projects on a free account, the user should be able to see and click a button directly under the welcome header labeled Upload and it should open a new project page/modal                                                                                                                                                                           |          |
|                                | Click New Project Button                  | If the user clicks a button on the upmost right side of the project stats header called, "New Project" and it should open a new project page                                                                                                                                                                                                                           |          |
|                                | Last 30 Days Project Stats Button         | As a user with no projects on a free account, the user should still be able to see and click a button next to the aforementioned button labeled, "Last 30 days" and clicking it should not change the project stats on-page as the user has no previous projects                                                                                                       |          |
|                                | Daily Storage Project Stats               | If a user has no projects on a free account, then there should be no displayed activity graph showing storage used per day                                                                                                                                                                                                                                             |          |
|                                | Daily Bandwidth Project Stats             | If a user has no projects on a free account, then there should be no displayed activity graph showing bandwidth used per day                                                                                                                                                                                                                                           |          |
|                                | More Info Button- Bandwidth project Stats | As a user with no projects on a free account, If the user clicks on the more info button on the bandwidth project stat graph, then the user should then be forwarded to documentation explaining allocated vs settled bandwidth                                                                                                                                        |          |
|                                | Total Billing Charge                      | If a user has no projects as a free account, then the user should not be billed and see no charges (0 dollars billed) under the billing section of the project dashboard                                                                                                                                                                                               |          |
|                                | Total Object Size                         | If a user has no projects as a free account, then the user should see 0 total GB of space used by objects under the object section of the project dashboard                                                                                                                                                                                                            |          |
|                                | Total Object Count                        | If a user has no projects as a free account, then the user should see 0 for total object count under the objects section of the project dashboard                                                                                                                                                                                                                      |          |
|                                | Total Segment Count                       | If a user has no projects as a free account, then the user should see 0 total segments under the segment section of the project dashboard                                                                                                                                                                                                                              |          |
|                                | Learn More Link Under Segments            | As a user with no projects on a free account, if the user clicks on the learn more link under the segments section, the user should then be forwarded to segments documentation(pricing and billing)                                                                                                                                                                   |          |
| Empty Slate- Pro Account       | Welcome Header Message                    | If a user has no projects on a pro account, then the user should be able to see the welcome header displaying the message, "Welcome to Storj :) You're ready to experience the future of cloud storage                                                                                                                                                                 |          |
|                                | Project Stats Delay Message               | Even if a user has no projects on a pro account, the user should still be able to see a message under the Project Stats header which alerts the user that the project storage and bandwidth activities take a few hours to show up on the graphs                                                                                                                       |          |
|                                | Click Upload Button                       | As a user with no projects on a proaccount, the user should be able to see and click a button directly under the welcome header labeled Upload and it should open a new project page                                                                                                                                                                                   |          |
|                                | Click New Project Button                  | If the user clicks a button on the upmost right side of the project stats header called, "New Project" and it should open a new project page/modal                                                                                                                                                                                                                     |          |
|                                | Last 30 Days Project Stats Button         | As a user with no projects on a pro account, the user should still be able to see and click a button next to the aforementioned button labeled, "Last 30 days" and clicking it should not change the project stats on-page as the user has no previous projects                                                                                                        |          |
|                                | Daily Storage Project Stats               | If a user has no projects on a pro account, then there should be no displayed activity graph showing storage used per day                                                                                                                                                                                                                                              |          |
|                                | Daily Bandwidth Project Stats             | If a user has no projects on a pro account, then there should be no displayed activity graph showing bandwidth used per day                                                                                                                                                                                                                                            |          |
|                                | More Info Button- Bandwidth project Stats | As a user with no projects on a pro account, If the user clicks on the more info button on the bandwidth project stat graph, then the user should then be forwarded to documentation explaining allocated vs settled bandwidth                                                                                                                                         |          |
|                                | Total Billing Charge                      | If a user has no projects as a pro account, then the user should not be billed and see no charges (0 dollars billed) under the billing section of the project dashboard                                                                                                                                                                                                |          |
|                                | Display Next Charge in Billing            | Even if a user has no projects on a pro account, the user should still be able to see the next time the user will be charged for any future usage before that stated billing date                                                                                                                                                                                      |          |
|                                | Total Object Size                         | If a user has no projects on a pro account, then the user should see 0 total GB of space used by objects under the object section of the project dashboard                                                                                                                                                                                                             |          |
|                                | Total Object Count                        | If a user has no projects as a pro account, then the user should see 0 for total object count under the objects section of the project dashboard                                                                                                                                                                                                                       |          |
|                                | Total Segment Count                       | If a user has no projects on a proaccount, then the user should see 0 total segments under the segment section of the project dashboard                                                                                                                                                                                                                                |          |
|                                | Learn More Link Under Segments            | As a user with no projects on a pro account if the user clicks on the learn more link under the segments section, then the user should then be forwarded to segments documentation(pricing and billing)                                                                                                                                                                |          |
| One Project- Free Account      | Object/Segment Header Message             | While a user has one project on a free account, if the user goes to their dashboard page then the user should see in their header message how many objects and segments they have stored around the world                                                                                                                                                              |          |
|                                | Project Stats Delay Message               | Even if a user has a single project on a free account with visible storage and bandwidth activity, the user should be able to see a message under the Project Stats header which alerts the user that the project storage and bandwidth activities take a few hours to show up on the graphs                                                                           |          |
|                                | Click New Project Button                  | If the user clicks a button on the upmost right side of the project stats header called, "New Project" and it should open a new project page/modal                                                                                                                                                                                                                     |          |
|                                | Last 30 Days Project Stats Button         | The user should still be able to see and click a button next to the aforementioned button labeled, "Last 30 days" and clicking it should bring up the graph stats for the last 30 days                                                                                                                                                                                 |          |
|                                | Daily Storage Project Stats               | If a user has one project on a free account, then there should be a displayed activity graph showing storage used per day                                                                                                                                                                                                                                              |          |
|                                | Daily Bandwidth Project Stats             | If a user has one project on a free account, then there should be a displayed activity graph showing bandwidth (allocated and settled) used per day                                                                                                                                                                                                                    |          |
|                                | Click on Specific Date on Storage Graph   | If a user has one project on a free account and clicks on the storage graph aligning to a specific date, it should then show the total amount of storage used for that day                                                                                                                                                                                             |          |
|                                | Click on Specific Date on Bandwidth Graph | If a user has one project on a free account and clicks on the bandwidth graph aligning to a specific date, it should then show the total amount of allocated and settled bandwidth for that day                                                                                                                                                                        |          |
|                                | More Info Button- Bandwidth project Stats | If the user clicks on the more info button on the bandwidth project stat graph, then the user should then be forwarded to documentation explaining allocated vs settled bandwidth                                                                                                                                                                                      |          |
|                                | Total Billing Charge                      | If a user has only one project as a free account, then the user should not be billed and see no charges (0 dollars billed) under the billing section of the project dashboard unless the user goes over free tier limits                                                                                                                                               |          |
|                                | Total Object Size                         | If the user looks under Object total size under the objects tab, then the user should see the corresponding total GB of space used by objects under that project                                                                                                                                                                                                       |          |
|                                | Total Object Count                        | If the user looks under Object count under the objects tab, then the user should see a set number of objects that is not zero for that project                                                                                                                                                                                                                         |          |
|                                | Total Segment Count                       | If the user looks under the Segment count under the segments tab, then the user should see the corresponding total segment number for their single project                                                                                                                                                                                                             |          |
|                                | Learn More Link Under Segments            | If the user clicks on the learn more link under the segments section, the user should then be forwarded to segments documentation                                                                                                                                                                                                                                      |          |
|                                | Correct Segment Number Header             | While a user has one project on a free account, if the user goes to their dashboard page then the user should see in their header message and in their segment count the same number of total segments                                                                                                                                                                 |          |
|                                | Correct Object Number Header              | While a user has one project on a free account, if the user goes to their dashboard page then the user should see in their header message one less object than in their object count                                                                                                                                                                                   |          |
| One Project- Pro Account       | Object/Segment Header Message             | While a user has one project on a pro account, if the user goes to their dashboard page then the user should see in their header message how many objects and segments they have stored around the world                                                                                                                                                               |          |
|                                | Project Stats Delay Message               | Even if a user has a single project on a paid account with visible storage and bandwidth activity, the user should be able to see a message under the Project Stats header which alerts the user that the project storage and bandwidth activities take a few hours to show up on the graphs                                                                           |          |
|                                | Click New Project Button                  | If the user clicks a button on the upmost right side of the project stats header called, "New Project" and it should open a new project modal/page                                                                                                                                                                                                                     |          |
|                                | Last 30 Days Project Stats Button         | The user should still be able to see and click a button next to the aforementioned button labeled, "Last 30 days" and clicking it should bring up the graph stats for the last 30 days                                                                                                                                                                                 |          |
|                                | Daily Storage Project Stats               | If a user has one project on a paid account, then there should be a displayed activity graph showing storage used per day                                                                                                                                                                                                                                              |          |
|                                | Daily Bandwidth Project Stats             | If a user has one project on a paid account, then there should be a displayed activity graph showing bandwidth (allocated and settled) used per day                                                                                                                                                                                                                    |          |
|                                | Click on Specific Date on Storage Graph   | If a user has one project on a paid account and clicks on the storage graph aligning to a specific date, it should then show the total amount of storage used for that day                                                                                                                                                                                             |          |
|                                | Click on Specific Date on Bandwidth Graph | If a user has one project on a paid account and clicks on the bandwidth graph aligning to a specific date, it should then show the total amount of allocated and settled bandwidth for that day                                                                                                                                                                        |          |
|                                | More Info Button- Bandwidth project Stats | If the user clicks on the more info button on the bandwidth project stat graph, then the user should be forwarded to documentation explaining allocated vs settled bandwidth                                                                                                                                                                                           |          |
|                                | Total Billing Charge                      | If a user has a pro account with one project that is utilizing sufficient storage and bandwidth to be billed, then the user should be billed and see charges (a dollar amount) under the billing section of their project dashboard                                                                                                                                    |          |
|                                | Display Next Charge in Billing            | Under the billing tab, the user should still be able to see the next time the user will be charged for any future usage before that stated billing date                                                                                                                                                                                                                |          |
|                                | Total Object Size                         | If the user looks under Object total size under the objects tab, then the user should see the corresponding total GB of space used by objects under that project                                                                                                                                                                                                       |          |
|                                | Total Object Count                        | If the user looks under Object count under the objects tab, then the user should see a set number of objects that is not zero for that project                                                                                                                                                                                                                         |          |
|                                | Total Segment Count                       | If the user looks under the Segment count under the segments tab, then the user should see the corresponding total segment number for their single project                                                                                                                                                                                                             |          |
|                                | Learn More Link Under Segments            | If the user clicks on the learn more link under the segments section, the user should then be forwarded to segments documentation                                                                                                                                                                                                                                      |          |
|                                | Correct Segment Number Header             | While a user has one project on a paid account, if the user goes to their dashboard page then the user should see in their header message and in their segment count the same number of total segments                                                                                                                                                                 |          |
|                                | Correct Object Number Header              | While a user has one project on a paid account, if the user goes to their dashboard page then the user should see in their header message one less object than in their object count                                                                                                                                                                                   |          |
| Multiple Projects- Pro Account | Project Stats Delay Message               | The user should be able to see a message under the Project Stats header, which alerts the user that the project storage and bandwidth activities take a few hours to show up on the graphs                                                                                                                                                                             |          |
|                                | Click Manage Projects Button              | If the user clicks a button on the upmost right side of the project stats header called, "Manage Projects" and it should open up manage projects modal/page                                                                                                                                                                                                            |          |
|                                | Last 30 Days Project Stats Button         | The user should be able to see and click a button next to the aforementioned button labeled, "Last 30 days" and clicking it should bring up the graph stats for the last 30 days                                                                                                                                                                                       |          |
|                                | Daily Storage Project Stats               | If a user has multiple projects on a paid account, then there should be a displayed activity graph showing storage used per day for those projects                                                                                                                                                                                                                     |          |
|                                | Daily Bandwidth Project Stats             | If a user has multiple projects on a paid account, then there should be a displayed activity graph showing bandwidth (allocated and settled) used per day for those projects                                                                                                                                                                                           |          |
|                                | Click on Specific Date on Storage Graph   | If a user clicks on the storage graph aligning to a specific date, it should then show the total amount of storage used for that day for all projects                                                                                                                                                                                                                  |          |
|                                | Click on Specific Date on Bandwidth Graph | If a user clicks on the bandwidth graph aligning to a specific date, it should then show the total amount of bandwidth (allocated and settled) used for that day for all projects                                                                                                                                                                                      |          |
|                                | More Info Button- Bandwidth project Stats | If the user clicks on the more info button on the bandwidth project stat graph, then the user should be forwarded to documentation explaining allocated vs settled bandwidth                                                                                                                                                                                           |          |
|                                | Multiple Project Header                   | While a user has multiple projects on a pro account and navigates to their dashboard, the user should then see under their project stats a section for said multiple projects with the header "Stats by Project"                                                                                                                                                       |          |
|                                | Separate Project Stat Graphs              | While a user has multiple projects under project stats, if the user then clicks on each separate project the user should then see the graphs of storage and bandwidth change for each separate project                                                                                                                                                                 |          |
|                                | Empty Project in Stats By Project         | While a user has multiple projects under project stats, if the user looks under the stats for an empty project then for this project there should be no objects, segments, billing fees, and no usage of storage and bandwidth                                                                                                                                         |          |
|                                | Filled Project in Stats by Project        | While a user has multiple projects under project stats, if the user looks under the stats for a filled project then for this project there should be object counts, segment counts, billing fees, and overall usage of storage and bandwidth                                                                                                                           |          |
|                                | Click New Project Button                  | If the user clicks a button on the rightmost side of the stats by project header, then open a new project modal/page should open                                                                                                                                                                                                                                       |          |
|                                | Stats By Project- Segment Count           | If the user looks under the Segment section under each projects tab under stats by project, then the user should see the corresponding total segment number for that project                                                                                                                                                                                           |          |
|                                | Stats By Project- Object Count            | If the user looks under the Object section under each projects tab under stats by project, then the user should see the corresponding total object number for that project                                                                                                                                                                                             |          |
|                                | Stats By Project- Billing Amount          | If the user looks under the Billing section under each projects tab under stats by project, then the user should see the corresponding total billing amount need for that project for this month so far                                                                                                                                                                |          |
|                                | Stats By Project- Average Total Storage   | If the user looks under the storage graph under each projects tab under stats by project, then the user should see the corresponding total storage amount set and average daily used for that project for this month                                                                                                                                                   |          |
|                                | Stats By Project- Average Total Bandwidth | If the user looks under the bandwidth graph under each projects tab under stats by project, then the user should see the corresponding total bandwidth amount set (allocated) and average daily used (settled) for that project for this month                                                                                                                         |          |
|                                | Learn More Link Under Segments            | If the user clicks on the learn more link under each projects segments section, the user should then be forwarded to segments documentation                                                                                                                                                                                                                            |          |
| Project Stats                  | Accurate Used Space- last 30 days         | If a user has a specific amount of used space under a certain project shown in the last 30 days by clicking on the last 30 days button to show results, then from comparing it with the DB from those 30 days user can see that used space data is accurate                                                                                                            |          |
|                                | Accurate Used Space- last 7 days          | If a user has a specific amount of used space under a certain project shown in the last seven days just by clicking on the project stats graph for said project and seeing the actual amount of avg used space for that day, then from comparing it with the DB from that specific date for said user and project one can test to see if that data is accurate         |          |
|                                | Accurate Used Bandwidth- last 30 days     | If a user has a specific amount of used bandwidth under a certain project shown in the last 30 days by clicking on the last 30 days button to show results, then from comparing it with the DB from those 30 days user can see that used bandwidth data is accurate                                                                                                    |          |
|                                | Accurate Used Bandwidth- last 7 days      | If a user has a specific amount of used bandwidth under a certain project shown in the last seven days just by clicking on the project stats graph for said project and seeing the actual amount of avg used bandwidth for that day, then from comparing it with the DB from that specific date for said user and project one can test to see if that data is accurate |          |
|                                | Accurate Billing Estimation               | If a user has a specific amount of used bandwidth, used space, and segment count the billing estimation should reflect these and follow standard pricing for the avg used bandwidth, space and number of segments                                                                                                                                                      |          |
|                                | No Tally Result                           | If there is no tally result for a day, then on the graphs it should show the previous days results                                                                                                                                                                                                                                                                     |          |
|                                | Used Space- Show Average                  | When there is a tally and used space is tracked, on the graph, it should show the average used space rather than the existing tally result for the day                                                                                                                                                                                                                 |          |
